import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeEvery } from 'redux-saga/effects';

import Action from '@overflow/commons/redux/Action';
import SagaWatcher from '@overflow/commons/redux/saga/SagaWatcher';
import * as AsyncRestRequestActions  from '@overflow/commons/redux/action/asyncRestRequest';
import AsyncRestRequestPayload from '@overflow/commons/redux/payload/AsyncRestRequestPayload';


import * as AppAsyncRestRequestSendingActions  from '../action/asyncRestRequestSending';

export class AsyncRestRequest implements SagaWatcher {
  private _restUrl: string;

  public setRestUrl(url: string): void {
    this._restUrl = url;
  }

  private * request(restUrl: string, action: Action<AsyncRestRequestPayload>): SagaIterator {
    const {entry, method, requestType, args} = action.payload;
    console.log(JSON.stringify(args));

    try {
      yield put(AppAsyncRestRequestSendingActions.sending(false));

      let result = yield call(
            fetch,
            restUrl + entry,
            {
            method: method,
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify(args),
          },
        );


      // let result = yield call(this.fetchApi2, entry, method, args);
      // let result = yield call({context: this, fn: this.fetchApi2}, entry, method, args);

      yield put(AsyncRestRequestActions.requestSuccess(requestType, result));
    } catch (e) {
      yield put(AsyncRestRequestActions.requestFailure(requestType, e));
    } finally {
      yield put(AppAsyncRestRequestSendingActions.sending(true));
    }
  }

  public * watch(): SagaIterator {
    yield takeEvery(AsyncRestRequestActions.REQUEST, this.request, this._restUrl);
  }

  public fetchApi2(uri: string, method:string, args:any): any {
    return fetch(
      'http://192.168.1.103:19080/account/' + uri, {
        method: method,
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(args),
      },
    )
    .then((response) => {
      return (response.status === 200) ? response.json() : Promise.reject('logon');
    });
    // .catch(err => {
    //   Promise.reject(err);
    // });
  }


  public fetchApi(uri: string, method:string, args:any): Promise<any> {
    return fetch(
      'http://192.168.1.103:19080/account/' + uri, {
        method: method,
        headers: {
          'Accept': 'application/json',
          'Content-Type': 'application/json',
        },
        body: JSON.stringify(args),
      },
    );
      // .then((response:any) => {
      //   console.log(response);
      //   return response;
      // })
      // .then((json:any) => {
      //   return json;
      // })
      // .catch(err => {
      //   return err;
      // });
  }
//
//   let d: any = await fetch('http://192.168.1.103:19080/account/forgot_password', {
//   method: 'POST',
//   headers: {
//     // 'Content-Type': 'text/plain; charset=utf-8',
//     'Accept': 'application/json',
//     'Content-Type': 'application/json',
//   },
//   body: JSON.stringify({
//   signinId: 'geek@loafle.com',
// }),
//
// }).then((respnse:any) => {
//   console.log(respnse);
//   return respnse.json();
// }).then((resData:any) => {
//   console.log('resdata' + resData);
//   return resData;
// }).catch(err => {
//   console.log('eee' + err);
// });

}

export default AsyncRestRequest;
