import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';


import * as CheckAuthCrawlerActionTypes from '../action/check_auth_crawler';
import CheckAuthCrawlerState, { defaultState as CheckAuthCrawlerDefaultState } from '../state/CheckAuthCrawler';

const reducer: ReducersMapObject = {
  [CheckAuthCrawlerActionTypes.REQUEST_SUCCESS]: (state: CheckAuthCrawlerState = CheckAuthCrawlerDefaultState,
                                                  action: Action<boolean>): CheckAuthCrawlerState => {
    return {
      ...state,
      isSuccessCheckAuthCrawler: action.payload,
    };
  },
  [CheckAuthCrawlerActionTypes.REQUEST_FAILURE]: (state: CheckAuthCrawlerState = CheckAuthCrawlerDefaultState,
                                                  action: Action<Error>): CheckAuthCrawlerState => {
    return {
      ...state,
      error: action.error,
    };
  },
};

export default reducer;
