import *as React from 'react';
import Member from '../../api/model/Member';

import {
  InputOnChangeData,
  CheckboxProps,
  Button,
  Form,
  ButtonProps,
} from 'semantic-ui-react';
import MemberStatus from '../../api/model/MemberStatus';

export interface StateProps {
  member?:Member;
}

export interface DispatchProps {
  onSignUp?(member: Member): void;
  onRedirectHome():void;
}

export type Props = StateProps & DispatchProps;

export interface State {
  email: string;
  name: string;
  pass: string;
  passCon: string;
  company: string;
  phone: string;
  country: string;
  checked: boolean;
}

// const options = [
//   { key: 'southkorea', value: '82', text: 'South Korea(82)' },
//   { key: 'unitedstates', value: '1', text: 'United States(1)' },
// ];


export class SignUp extends React.Component<Props, State> {
  constructor(props?: Props, context?: State) {
    super(props, context);

    this.state = {
      email: null,
      name: null,
      pass: null,
      passCon: null,
      company: null,
      phone: null,
      country: null,
      checked: false,
    };

  }

  public onChange (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData):void {
    console.log(event);
    console.log(data);
  }

  public render(): JSX.Element {

    let signupElement = <Form>
      <Form.Input fluid value={this.state.email} placeholder='Email' onChange={
        // Todo Email Check
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ email: data.value });
        }} />
      <Form.Input fluid placeholder='Name' onChange= {
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ name: data.value });
        }
      }/>
      <Form.Input fluid placeholder='Password' prompt='dfsdfs' type='password' onChange={
        // Todo Password Complexity Check & Length Check (8 characters or more and 50 characters or less)
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ pass: data.value });
        }
      } />
      <Form.Input fluid placeholder='Password Confirm' type='password' onChange={
        // Todo Password Equal Check
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ passCon: data.value });
        }
      } />
      <Form.Input fluid placeholder='Company' onChange={
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ company: data.value });
        }
      }/>
      {/* <Form.Select fluid value={this.state.country} placeholder='Select your country' options={options} onChange={
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ country: data.value });
        }
      } /> */}
      <Form.Input fluid placeholder='phone' onChange={
        (event: React.SyntheticEvent<HTMLInputElement>, data: InputOnChangeData) => {
          this.setState({ phone: data.value });
        }
      } />
      <Form.Checkbox label={<label>I accept <a href = '/' target='_blank'> Term </a>and
        <a href='/' target='_blank'>privacy</a></label>} onClick={
        (event: React.MouseEvent<HTMLInputElement>, data: CheckboxProps) => {
          if (this.state.checked) {
            this.setState({ checked: false });
          } else {
            this.setState({ checked: true });
          }
        }
      } />

      <Form.Group>
        <Button primary fluid style={{margin:'2'}} onClick={this.signUpClick}>   Join Now </Button>
      </Form.Group>
      <Form.Group>
        <Button fluid style={{margin:'5'}}>    Cancel  </Button>
        <Button primary fluid style={{margin:'5'}} onClick={this.signinClick}>   Sign In  </Button>
      </Form.Group>
    </Form>;
    if (this.props.member !== undefined && this.props.member.id > 0) {
      // Todo Please check the member registration e-mail.
      this.props.onRedirectHome();
    } else {
      return signupElement;
    }

  }

  private signinClick = (event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void => {
    return;
  }

  private signUpClick = (event: React.SyntheticEvent<HTMLButtonElement>, data: ButtonProps):void => {

    let member:Member = {};
    member.pw = this.state.pass;

    if (member.pw !== this.state.passCon) {
      return;
    }

    member.email = this.state.email;
    member.name = this.state.name;
    member.companyName = this.state.company;
    member.phone = this.state.phone;
    // member.status = MemberStatus.NOAUTH;

    this.props.onSignUp(member);
  }

}

