import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';
import Member from '@overflow/member/api/model/Member';

import * as ForgotPasswordTypes from '../action/forgot_password';
import ForgotPasswordState, { defaultState as forgotDefaultState } from '../state/ForgotPassword';

const reducer: ReducersMapObject = {
  [ForgotPasswordTypes.REQUEST_SUCCESS]: (state: ForgotPasswordState = forgotDefaultState, action: Action<Member>): ForgotPasswordState => {
    return {
      ...state,
      isSendMail: true,
    };
  },
  [ForgotPasswordTypes.REQUEST_FAILURE]: (state: ForgotPasswordState = forgotDefaultState, action: Action<Error>): ForgotPasswordState => {
    if (action.error.name === 'SignInPwNotMatchException') {
      //
    }
    return {
      ...state,
      error: new Error('ForgotPassword Error'),
    };
  },
};

export default reducer;
