
import Action from '@overflow/commons/redux/Action';
import { ReducersMapObject } from 'redux';


import * as SensorDisplayItemReadAllByCrawlerActions from '../action/sensor_display_item_read_all_by_crawler';
import SensorDisplayItemReadAllByCrawlerState,
{ defaultState as SensorDisplayItemReadAllByCrawlerDefaultState }
  from '../state/SensorDisplayItemReadAllByCrawler';

import MetaSensorDisplayItem from '../../api/model/MetaSensorDisplayItem';

const reducer: ReducersMapObject = {
  [SensorDisplayItemReadAllByCrawlerActions.REQUEST_SUCCESS]:
  (state: SensorDisplayItemReadAllByCrawlerState = SensorDisplayItemReadAllByCrawlerDefaultState, action: Action<MetaSensorItemKey[]>):
    SensorDisplayItemReadAllByCrawlerState => {
    return {
      ...state,
      sensorDisplayItems: <MetaSensorDisplayItem[]>action.payload,
    };
  },
  [SensorDisplayItemReadAllByCrawlerActions.REQUEST_FAILURE]:
  (state: SensorDisplayItemReadAllByCrawlerState = SensorDisplayItemReadAllByCrawlerDefaultState, action: Action<Error>):
  SensorDisplayItemReadAllByCrawlerState => {
    return state;
  },
};

export default reducer;
