import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon, Grid,
} from 'semantic-ui-react';
import { SensorConfigTarget } from './sensor_config_target';
import { SensorConfigCrawler } from './sensor_config_crawler';
import { SensorConfigAuthCrawler } from './sensor_config_auth_crawler';
import { SensorConfigItem } from './sensor_config_item';
import { SensorConfigSetting } from './sensor_config_setting';

export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
}

export class SensorConfig extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      selected: null,
    };
  }


  public render(): JSX.Element {
    return (
      <Container>
        <Grid columns={2} divided>
          <Grid.Row>
            <Grid.Column >
              Target Select
        <SensorConfigTarget />
            </Grid.Column>
            <Grid.Column>
              Auth Crawler
        <SensorConfigAuthCrawler />
            </Grid.Column>
          </Grid.Row>
          <Grid.Row>
            <Grid.Column>
              Crawler Select
        <SensorConfigCrawler />
            </Grid.Column>
            <Grid.Column>
              Sensor Item
        <SensorConfigItem />
            </Grid.Column>
          </Grid.Row>
        </Grid>
        Sensor Setting
        <SensorConfigSetting />

        <Button floated='left'>Cancel</Button>
        <Button floated='right'>Next</Button>
      </Container>
    );
  }

}
