import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon,
} from 'semantic-ui-react';
import {ItemTree, ItemTreeObj} from './item_tree';

export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  testItemTreeList: Array<ItemTreeObj>;
}

export class SensorConfigItem extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      testItemTreeList: new Array(),
    };

    this.testData();
  }

  public testData(): void {
        let item: ItemTreeObj = {
          icon: 'chevron up|chevron down',
          isCheckBox: true,
          label: 'CPU',
        };

        item.children = new Array();

        item.children.push({
          isCheckBox: true,
          label: 'CPU Total Usage(%)',
        });
        item.children.push({
          isCheckBox: true,
          label: 'CPU Free Usage(%)',
        });

        this.state.testItemTreeList.push(item);
      }


  public render(): JSX.Element {
    return (
      <Container>
          <ItemTree ItemTreeList={this.state.testItemTreeList}/>
      </Container>
    );
  }

}
