import * as React from 'react';
import {
  Table, Header, Container, Form, Checkbox, Button, Rating,
  List, Icon,
} from 'semantic-ui-react';
import {ItemTree, ItemTreeObj} from './item_tree';


export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  testItemTreeList: Array<ItemTreeObj>;
}

export class SensorConfigTarget extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);

    this.state = {
      testItemTreeList: new Array(),
    };

    this.testData();
  }

  private testData(): void {

    let item: ItemTreeObj = {
      icon: 'chevron up|chevron down',
      isCheckBox: false,
      label: 'Host',
    };

    item.children = new Array();

    for(let idx: number = 0; idx < 10; ++idx) {
      item.children.push({
        isCheckBox: true,
        label: '192.168.1.' + String(idx + 1),
      });
    }

    this.state.testItemTreeList.push(item);
  }


  public render(): JSX.Element {
    return (
      <Container>
        <ItemTree ItemTreeList={this.state.testItemTreeList}/>
      </Container>
    );
  }

}
